/*============================================================================
//	apci57w.cs
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;


namespace SampleA57
{
	/// <summary>
	/// Apci57w ̊Tv̐łB
	/// </summary>
	public class Apci57w
	{
		private int mErrWradll = SUCCESS;	// bp[֐G[

		// őXbg
		public const int MAX_SLOTS				= 16;

		// _Xbgw
		public const short SLOT_AUTO			= -1;

		// G[R[h̒`
		public const int ERR_INTERNAL			= 5100;	// Send mail to us
		public const int ERR_UNKNOWN			= 5101;	// Help me!
		public const int SUCCESS				= 0;	// I
		public const int ERR_NO_DEVICE			= 5000;	// No device or not an aPCI-A57
		public const int ERR_RESOURCE			= 5001;	// Resource exhaustion
		public const int ERR_INVALID_ARG		= 5002;	// Invalid argument(s)
		public const int ERR_SLOT				= 5003;	// _Xbgԍsłi܂͌܂j
		public const int ERR_CHANNEL			= 5004;	// `lw肪sł
		public const int ERR_TIMER				= 5005;	// ^C}lsł
		public const int ERR_NOT_ENOUGH_MEM		= 5006;	// \ȃmۂł܂ł
		public const int ERR_NUMDATA			= 5007;	// w肳ꂽ̃f[^obt@ɑ݂܂
		public const int ERR_NOT_CREATED		= 5008;	// foCXNGCgĂ܂
		public const int ERR_START				= 5009;	// X^[gɎs܂B
		public const int ERR_INVALID_FUNC		= 5010;	// Ȋ֐Ăяoł
		public const int ERR_IN_USE				= 5011;	// gp̃foCXł(NT)
		public const int ERR_FIFO				= 5012;	// FIFOڂĂȂ
		public const int ERR_WRAPDLL			= -1;	// bp[֐G[

		// TvO[h̒`
		//												   START  SAMPLING	CLK    obt@[h
		public const int MODE_01				= 1;	// soft	  single	---    hCo
		public const int MODE_02				= 2;	// soft	  burst		timer@hCo
		public const int MODE_03				= 3;	// extrg  single	---@@hCo
		public const int MODE_04				= 4;	// extrg  burst		timer@hCo
		public const int MODE_05				= 5;	// soft	  burst		timer@foCX
		public const int MODE_06				= 6;	// extrg  burst		timer@foCX

		// bZ[W
		// Apci57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
		// ItZbglbZ[Wo܂B
		public const int WM_EOC					= 0;	// VOTvO̊
		public const int WM_BUFF_HALF_FULL		= 1;	// hCoOobt@̃n[tt
		public const int WM_BUFF_FULL			= 2;	// hCoOobt@̃t
		public const int WM_BUFF_OVERFLOW		= 3;	// hCoOobt@̃I[o[t[
		public const int WM_SAMPLING_OVERRUN	= 4;	// `lEI[gECNg̃I[o[

		// foCXXe[^XR[h
		public const int STS_SAMPLING			= 0x01;
		public const int STS_EOC				= 0x02;
		public const int STS_BUFF_HALF_FULL		= 0x04;
		public const int STS_BUFF_FULL			= 0x08;
		public const int STS_BUFF_OVERFLOW		= 0x10;
		public const int STS_SAMPLING_OVERRUN	= 0x20;

		// A/D`lݒl͈̔
		public const int ADCH_FIRST				= 0;
		public const int ADCH_LAST				= 7;

		// A/D`lݒl
		public const int ADCH_01				= 0;
		public const int ADCH_02				= 1;
		public const int ADCH_03				= 2;
		public const int ADCH_04				= 3;
		public const int ADCH_05				= 4;
		public const int ADCH_06				= 5;
		public const int ADCH_07				= 6;
		public const int ADCH_08				= 7;

		// D/A`lݒl
		public const int DACH_01				= 0;
		public const int DACH_02				= 1;

		// I/O\[XzE
		public const int MAX_MEM				= 9;	// MAX_MEM_REGISTERS
		public const int MAX_IO					= 20;	// MAX_IO_PORTS
		public const int MAX_IRQ				= 7;	// MAX_IRQS
		public const int MAX_DMA				= 7;	// MAX_DMA_CHANNELS
		public const int MAX_RSV				= 3;	// MAX_Reserved1

		// \[X
		[StructLayout(LayoutKind.Sequential)]
		public struct Resource
		{
			public int		dwNumMemWindows;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemLength;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemAttrib;
			public int		dwNumIOPorts;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortLength;
			public int		dwNumIRQs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQRegisters;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQAttrib;
			public int		dwNumDMAs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMALst;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMAAttrib;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_RSV)]
			public int[]	dwReserved1;
		}

		// TvO[h
		[StructLayout(LayoutKind.Sequential)]
		public struct Mode
		{
			public int		dwChFirst;	// TvOJn`l(0 ` 7) 
			public int		dwChLast;	// TvOI`l(0 ` 7)
			public int		cwBuffer;	// obt@TCYi[hPʁj
			public int		dwTimer;	// ^C}l(00H ` 3FH)
			public int		dwMode;		// 샂[h(1 ` 6)
		}

		// API
		[DllImport("apci57.dll")]
		public extern static unsafe bool Apci57GetVersion(int* pdwDllVer, int* pdwDrvVer);
		[DllImport("apci57.dll")]
		public extern static unsafe bool Apci57Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg);
		[DllImport("apci57.dll")]
		public extern static        bool Apci57Close(short wLogSlot);
		[DllImport("apci57.dll")]
		public extern static        bool Apci57GetResource(short wLogSlot, ref Resource pres);
		[DllImport("apci57.dll")]
		public extern static unsafe bool Apci57GetSwitchValue(short wLogSlot, int* dwSwVal);
		[DllImport("apci57.dll")]
		public extern static        bool Apci57SetMode(short wLogSlot, ref Mode pmode);
		[DllImport("apci57.dll")]
		public extern static        bool Apci57StartSampling(short wLogSlot);
		[DllImport("apci57.dll")]
		public extern static        bool Apci57StopSampling(short wLogSlot);
		[DllImport("apci57.dll")]
		public extern static unsafe bool Apci57GetSamplingStatus(short wLogSlot, int* lpcwNumData, int* lpdwStatus);
		[DllImport("apci57.dll")]
		public extern static unsafe bool Apci57GetData(short wLogSlot, int cwNumData, short* lpwData);
		[DllImport("apci57.dll")]
		public extern static        bool Apci57SetData(short wLogSlot, short wChData, short wDaData);
		[DllImport("apci57.dll")]
		public extern static unsafe bool Apci57InPort(short wLogSlot, byte* lpbInValue);
		[DllImport("apci57.dll")]
		public extern static        bool Apci57OutPort(short wLogSlot, byte bOutValue);
		[DllImport("apci57.dll")]
		public extern static        int  Apci57GetLastError(short wLogSlot);

		public Apci57w()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		//==========================================================================
		// 	  aPCI-A57 DLL,Driver̃o[Wԍ擾	
		// 	  pdwDllVer DLLo[Wԍi[AhX
		//		  pdwDrvVer Drivero[Wԍi[AhX
		// ߂l  true
		//		  s false
		//==========================================================================
		public unsafe bool GetVersion(int* pdwDllVer, int* pdwDrvVer)
		{
			try
			{
				return Apci57GetVersion(pdwDllVer, pdwDrvVer);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  aPCI-A57̔Cӂ̃foCX̎gp錾
		// 	  pwLogSlot gpfoCXi[AhX
		//		  hWnd		bZ[W𑗂EBhEnh
		//		  uWMBase	ƂȂ郁bZ[WID
		//		  pvInitArg gp(NULLZbg)
		// ߂l  true
		//		  s false
		//==========================================================================
		public unsafe bool Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg)
		{
			try
			{
				return Apci57Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		//==========================================================================
		// 	  aPCI-A57̔Cӂ̃foCX̎gpJ
		// 	  wLogSlot gpfoCX
		// ߂l  true
		//		  s false
		//==========================================================================
		public bool Close(short wLogSlot)
		{
			try
			{
				return Apci57Close(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  wfoCX̃\[X擾
		// 	  wLogSlot ׂfoCX
		//		  pres	   \[Xi[\̂̃AhX
		// ߂l  true
		//		  s false
		//==========================================================================
		public bool GetResource(short wLogSlot, ref Resource pres)
		{
			try
			{
				return Apci57GetResource(wLogSlot, ref pres);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		//==========================================================================
		// 	  [^XCb`̒l擾
		// 	  wLogSlot		 ׂfoCX
		//		  pdwSwitchValue [^XCb`̒l
		// ߂l  true
		//		  s false
		//==========================================================================
		public unsafe bool GetSwitchValue(short wLogSlot, int* dwSwVal)
		{
			try
			{
				return Apci57GetSwitchValue(wLogSlot, dwSwVal);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		//==========================================================================
		// 	  TvO[h̐ݒ
		// 	  wLogSlot ݒ肷foCX
		//		  pcmode   [hݒf[^̃AhX
		// ߂l  true
		//		  s false
		//==========================================================================
		public bool SetMode(short wLogSlot, ref Mode pmode)
		{
			try
			{
				return Apci57SetMode(wLogSlot, ref pmode);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  TvOJn
		// 	  wLogSlot JnfoCX
		// ߂l  true
		//		  s false
		//==========================================================================
		public bool StartSampling(short wLogSlot)
		{
			try
			{
				return Apci57StartSampling(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  TvO~
		// 	  wLogSlot ~foCX
		// ߂l  true
		//		  s false
		//==========================================================================
		public bool StopSampling(short wLogSlot)
		{
			try
			{
				return Apci57StopSampling(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  TvOEXe[^X̎擾
		// 	  wLogSlot	 擾foCX
		//		  pcwNumData f[^obt@AhX
		//		  pdwStatus	 Xe[^XAhX
		// ߂l  true
		//		  s false
		//==========================================================================
		public unsafe bool GetSamplingStatus(short wLogSlot, int* lpcwNumData, int* lpdwStatus)
		{
			try
			{
				return Apci57GetSamplingStatus(wLogSlot, lpcwNumData, lpdwStatus);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  TvOς݃f[^̎擾
		// 	  wLogSlot	擾foCX
		//		  cwNumData vf[^
		//		  pwData	f[^obt@ւ̃AhX
		// ߂l  true
		//		  s false
		//==========================================================================
		public unsafe bool GetData(short wLogSlot, int cwNumData, short* lpwData)
		{
			try
			{
				return Apci57GetData(wLogSlot, cwNumData, lpwData);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  D/Af[^̏o
		// 	  wLogSlot	o͂foCX
		//		  wChData	݃`lw
		//		  wDaData	o͂D/Af[^
		// ߂l  true
		//		  s false
		//==========================================================================
		public bool SetData(short wLogSlot, short wChData, short wDaData)
		{
			try
			{
				return Apci57SetData(wLogSlot, wChData, wDaData);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  Cӂ̃|[gf[^
		// 	  wLogSlot	͂foCX
		//		  pbInValue ̓f[^i[AhX
		// ߂l  true
		//		  s false
		//==========================================================================
		public unsafe bool InPort(short wLogSlot, byte* lpbInValue)
		{
			try
			{
				return Apci57InPort(wLogSlot, lpbInValue);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  Cӂ̃|[gփf[^o
		// 	  wLogSlot	o͂foCX
		//		  bOutValue o͂f[^
		// ߂l  true
		//		  s false
		//==========================================================================
		public bool OutPort(short wLogSlot, byte bOutValue)
		{
			try
			{
				return Apci57OutPort(wLogSlot, bOutValue);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//==========================================================================
		// 	  aPCI-A57̃G[R[h
		// 	  wLogSlot	G[foCX
		// ߂l G[R[h
		//==========================================================================
		public int GetLastError(short wLogSlot)
		{
			try
			{
				if (mErrWradll == ERR_WRAPDLL)	// bp[֐G[Ȃ
				{
					mErrWradll = SUCCESS;		// NA
					return ERR_WRAPDLL;
				} 
				else 
				{
					return Apci57GetLastError(wLogSlot);
				}
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-A57 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return ERR_WRAPDLL;
			}
		}

	}
}
